# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

# Declaring specific app values (TO CHANGE)
bin_name_string = 'npcap-%s.exe'
silent_args = '' # This software isn't silent !
app_uninstallkey = 'NpcapInst'


def install():
    # Specific app values
    package_version = control.version.split('-',1)[0]
    bin_name = bin_name_string % package_version

    # Installing the package
    if running_as_system():
        if need_install(app_uninstallkey,min_version=package_version):
            error('This package (whitout licence) can only be run manually with "wapt-get install tis-npcap"')
    else:
        install_exe_if_needed(bin_name
            ,silentflags=silent_args
            ,key=app_uninstallkey
            ,min_version=package_version
            ,killbefore=bin_name)


def update_package():
    print('Download/Update package content from upstream binary sources')
    import requests,platform

    # Update transition from BeautifulSoup 3 to 4
    try:
        import bs4 as BeautifulSoup
    except:
        import BeautifulSoup

    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system()=='Windows' and isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}

    # Specific app values
    app_name = control.name
    url = control.sources

    # Getting latest version from official website
    page = requests.get(url).text
    bs = BeautifulSoup.BeautifulSoup(page)
    #bs = BeautifulSoup.BeautifulSoup(page,features="html.parser") # For bs4 only
    ul_download = bs.findAll('ul')[5]
    for li in ul_download.findAll('li'):
        if li.findChild().get('href').endswith('.exe'):
            part_url=li.findChild().get('href')
            #print(part_url)
            break

    url_dl = url + part_url
    latest_bin = part_url.split('/')[-1]

    version = (latest_bin.split('-')[-1]).replace('.exe','')

    print('Latest ' + app_name + ' version is: ' + version)
    print('Download url is: ' + url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print('Downloading: ' + latest_bin)
        wget(url_dl,latest_bin,proxies=proxy)

		# Change version of the package
        pe = PackageEntry().load_control_from_wapt('.')
        pe.version = '%s-%s'%(version,int(pe.version.split('-',1)[1])+1)
        pe.save_control_to_wapt('.')
        print('Changing version to ' + pe.version + ' in WAPT\\control')
        print('Update package done. You can now build-upload your package')
    else:
        print('This package is already up-to-date')

    # Deleting outdated binaries
    for bin_in_dir in glob.glob('*.exe') or glob.glob('*.msi') or glob.glob('*.zip'):
        if bin_in_dir != latest_bin :
            print('Outdated binary: ' + bin_in_dir + ' Deleted')
            remove_file(bin_in_dir)

